#!/usr/bin/env python

from MoinMessage import *
from email.mime.text import MIMEText
from email.parser import Parser
import sys

try:
    from cStringIO import StringIO
except ImportError:
    from StringIO import StringIO

if __name__ == "__main__":
    try:
        signer = sys.argv[1]
        recipient = sys.argv[2]
        url = sys.argv[3] + "?action=FetchMessages"
        args = sys.argv[4:]
    except IndexError:
        args = None

    if not args:
        print >>sys.stderr, "Need a signer, recipient, URL and some commands as arguments to this program."
        sys.exit(1)

    message = Message()
    parts = []

    part = MIMEText("\n".join(args), "plain", sys.stdin.encoding)
    message.add_update(part)

    email_message = message.get_payload()
    gpg = GPG()

    try:
        signed_message = gpg.signMessage(email_message, signer)
        encrypted_message = gpg.encryptMessage(signed_message, recipient)
        text = sendMessage(encrypted_message, url, "PUT")
        mailbox = Parser().parse(StringIO(text))

        if is_encrypted(mailbox):
            text = gpg.decryptMessage(mailbox)
            mailbox = Parser().parse(StringIO(text))

        if is_signed(mailbox):
            fingerprint, identity, content = gpg.verifyMessage(mailbox)
            print "Messages signed by", fingerprint, identity
        else:
            print "Message not signed!"

        print
        print content

    except MoinMessageError, exc:
        print exc

# vim: tabstop=4 expandtab shiftwidth=4
